Index: uspace/app/taskbar/types/wndlist.h
===================================================================
--- uspace/app/taskbar/types/wndlist.h	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/app/taskbar/types/wndlist.h	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -59,4 +59,6 @@
 	/** Window button rectangle */
 	gfx_rect_t rect;
+	/** Window maximized **/
+	bool maximized;
 } wndlist_entry_t;
 
Index: uspace/app/taskbar/wndlist.c
===================================================================
--- uspace/app/taskbar/wndlist.c	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/app/taskbar/wndlist.c	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -232,4 +232,5 @@
 
 	entry->visible = false;
+	entry->maximized = true;
 
 	ui_pbutton_set_light(entry->button, active);
@@ -722,6 +723,15 @@
 	dev_id = entry->wndlist->ev_idev_id;
 
-	(void) wndmgt_activate_window(entry->wndlist->wndmgt,
-	    dev_id, entry->wnd_id);
+	if (!entry->maximized) {
+		(void) wndmgt_activate_window(entry->wndlist->wndmgt,
+	        dev_id, entry->wnd_id);
+
+		entry->maximized = true;
+	} else {
+		(void) wndmgt_deactivate_window(entry->wndlist->wndmgt,
+	        dev_id, entry->wnd_id);
+
+		entry->maximized = false;
+	}
 }
 
Index: uspace/lib/wndmgt/include/ipc/wndmgt.h
===================================================================
--- uspace/lib/wndmgt/include/ipc/wndmgt.h	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/lib/wndmgt/include/ipc/wndmgt.h	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -43,4 +43,5 @@
 	WNDMGT_GET_WINDOW_INFO,
 	WNDMGT_ACTIVATE_WINDOW,
+	WNDMGT_DEACTIVATE_WINDOW,
 	WNDMGT_CLOSE_WINDOW,
 	WNDMGT_GET_EVENT,
Index: uspace/lib/wndmgt/include/wndmgt.h
===================================================================
--- uspace/lib/wndmgt/include/wndmgt.h	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/lib/wndmgt/include/wndmgt.h	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -48,4 +48,5 @@
 extern void wndmgt_free_window_info(wndmgt_window_info_t *);
 extern errno_t wndmgt_activate_window(wndmgt_t *, sysarg_t, sysarg_t);
+extern errno_t wndmgt_deactivate_window(wndmgt_t *, sysarg_t, sysarg_t);
 extern errno_t wndmgt_close_window(wndmgt_t *, sysarg_t);
 
Index: uspace/lib/wndmgt/include/wndmgt_srv.h
===================================================================
--- uspace/lib/wndmgt/include/wndmgt_srv.h	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/lib/wndmgt/include/wndmgt_srv.h	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -53,4 +53,5 @@
 	errno_t (*get_window_info)(void *, sysarg_t, wndmgt_window_info_t **);
 	errno_t (*activate_window)(void *, sysarg_t, sysarg_t);
+	errno_t (*deactivate_window)(void *, sysarg_t, sysarg_t);
 	errno_t (*close_window)(void *, sysarg_t);
 	errno_t (*get_event)(void *, wndmgt_ev_t *);
Index: uspace/lib/wndmgt/src/wndmgt.c
===================================================================
--- uspace/lib/wndmgt/src/wndmgt.c	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/lib/wndmgt/src/wndmgt.c	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -308,4 +308,26 @@
 }
 
+/** Deactivate (minimize) window.
+ *
+ * @param wndmgt Window management session
+ * @param dev_id ID of input device belonging to seat whose
+ *               focus is to be switched
+ * @param wnd_id Window ID
+ * @return EOK on success or an error code
+ */
+errno_t wndmgt_deactivate_window(wndmgt_t *wndmgt, sysarg_t dev_id,
+    sysarg_t wnd_id)
+{
+	async_exch_t *exch;
+	errno_t rc;
+
+	exch = async_exchange_begin(wndmgt->sess);
+	rc = async_req_2_0(exch, WNDMGT_DEACTIVATE_WINDOW, dev_id,
+	    wnd_id);
+
+	async_exchange_end(exch);
+	return rc;
+}
+
 /** Close window.
  *
Index: uspace/lib/wndmgt/src/wndmgt_srv.c
===================================================================
--- uspace/lib/wndmgt/src/wndmgt_srv.c	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/lib/wndmgt/src/wndmgt_srv.c	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -222,4 +222,22 @@
 }
 
+static void wndmgt_deactivate_window_srv(wndmgt_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t dev_id;
+	sysarg_t wnd_id;
+	errno_t rc;
+
+	dev_id = ipc_get_arg1(icall);
+	wnd_id = ipc_get_arg2(icall);
+
+	if (srv->ops->deactivate_window == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	rc = srv->ops->deactivate_window(srv->arg, dev_id, wnd_id);
+	async_answer_0(icall, rc);
+}
+
 static void wndmgt_close_window_srv(wndmgt_srv_t *srv, ipc_call_t *icall)
 {
@@ -308,4 +326,7 @@
 		case WNDMGT_ACTIVATE_WINDOW:
 			wndmgt_activate_window_srv(srv, &call);
+			break;
+		case WNDMGT_DEACTIVATE_WINDOW:
+			wndmgt_deactivate_window_srv(srv, &call);
 			break;
 		case WNDMGT_CLOSE_WINDOW:
Index: uspace/srv/hid/display/wmops.c
===================================================================
--- uspace/srv/hid/display/wmops.c	(revision 49aaa0e35a10f53802af5c8cb22cd8f46f1230bb)
+++ uspace/srv/hid/display/wmops.c	(revision 8eeffc12724890ee78571b31d0bac167386ceace)
@@ -47,4 +47,5 @@
 static errno_t dispwm_get_window_info(void *, sysarg_t, wndmgt_window_info_t **);
 static errno_t dispwm_activate_window(void *, sysarg_t, sysarg_t);
+static errno_t dispwm_deactivate_window(void *, sysarg_t, sysarg_t);
 static errno_t dispwm_close_window(void *, sysarg_t);
 static errno_t dispwm_get_event(void *, wndmgt_ev_t *);
@@ -54,4 +55,5 @@
 	.get_window_info = dispwm_get_window_info,
 	.activate_window = dispwm_activate_window,
+	.deactivate_window = dispwm_deactivate_window,
 	.close_window = dispwm_close_window,
 	.get_event = dispwm_get_event,
@@ -189,4 +191,32 @@
 }
 
+/** Deactivate (minimize) window.
+ *
+ * @param arg Argument (WM client)
+ * @param dev_id Input device ID
+ * @param wnd_id Window ID
+ * @return EOK on success or an error code
+ */
+static errno_t dispwm_deactivate_window(void *arg, sysarg_t dev_id,
+    sysarg_t wnd_id)
+{
+	ds_wmclient_t *wmclient = (ds_wmclient_t *)arg;
+	ds_window_t *wnd;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispwm_deactivate_window()");
+
+	ds_display_lock(wmclient->display);
+	wnd = ds_display_find_window(wmclient->display, wnd_id);
+	if (wnd == NULL) {
+		ds_display_unlock(wmclient->display);
+		return ENOENT;
+	}
+
+	ds_window_minimize(wnd);
+
+	ds_display_unlock(wmclient->display);
+	return EOK;
+}
+
 /** Close window.
  *
